/***********************************************************************
*                                                                      *
*                              SPECLASS                                *
*                                                                      *
*                                The                                   *
*                                                                      *
*                      Color Spectra Classifier                        *
*                                                                      *
*                          Program  Package                            *
*                                                                      *
*                           Programmed by			       *
*								       *
*			     J. Haanpalo		               *
*                                                                      *
*                      Copyright (c) 1993-1995                         *
*                                                                      *
************************************************************************
*                                                                      *
*  NOTE: This program package is copyrighted in the sense that it      *
*  may be used for scientific purposes. The package as a whole, or     *
*  parts thereof, cannot be included or used in any commercial         *
*  application without written permission granted by its producents.   *
*  No programs contained in this package may be copied for commercial  *
*  distribution. This program package comes 'as it is' and with no     *
*  warranty.                                                           *
*                                                                      *
*  All comments concerning this program package may be sent to the     *
*  e-mail address 'haanpalo@lut.fi'.                                   *
*                                                                      *
***********************************************************************/

#include <string.h>
#include <stdio.h>
#include <math.h>
#include <sys/wait.h>
#include "xglobal.h"
#include "global.h"
#include "matfile.h"

Panel_item aalpha_item, abeta_item, agamma_item, adelta_item, atheta_item, atpattern_item,
  attarget_item, ainput_item, aoutput_item, avig_item, alearn_item, atest_item,
  aepoch_item, aspeed_item, aneuron_item;

Event event;
void exec_artlearn(), test_artlearn();

void init_art_panel()
{
  if (art_panel) {
    xv_set(current_panel, XV_SHOW, FALSE, NULL);
    xv_set(art_panel, XV_SHOW, TRUE, NULL);
    current_panel = art_panel;
    return;
  }
  current_panel = art_panel = xv_create(frame, PANEL,
					XV_X, PANEL_X,
					XV_Y, PANEL_Y,
					XV_WIDTH, PANEL_WIDTH,
					XV_HEIGHT, PANEL_HEIGHT,
					NULL);

  aalpha_item = xv_create(art_panel, PANEL_TEXT,
			  XV_X, 0,
			  XV_Y, 0,
			  PANEL_LAYOUT, PANEL_VERTICAL,
			  PANEL_LABEL_STRING, "alpha",
			  PANEL_VALUE_DISPLAY_LENGTH, DISPLAY_LENGTH,
			  PANEL_VALUE_STORED_LENGTH, DISPLAY_LENGTH,
			  PANEL_VALUE, "2.0",
			  NULL);

  abeta_item = xv_create(art_panel, PANEL_TEXT,
			 XV_X, 100,
			 XV_Y, 0,
			 PANEL_LAYOUT, PANEL_VERTICAL,
			 PANEL_LABEL_STRING, "beta",
			 PANEL_VALUE_DISPLAY_LENGTH, DISPLAY_LENGTH,
			 PANEL_VALUE_STORED_LENGTH, DISPLAY_LENGTH,
			 PANEL_VALUE, "2.0",
			 NULL);

  agamma_item = xv_create(art_panel, PANEL_TEXT,
			  XV_X, 200,
			  XV_Y, 0,
			  PANEL_LAYOUT, PANEL_VERTICAL,
			  PANEL_LABEL_STRING, "gamma",
			  PANEL_VALUE_DISPLAY_LENGTH, DISPLAY_LENGTH,
			  PANEL_VALUE_STORED_LENGTH, DISPLAY_LENGTH,
			  PANEL_VALUE, "0.85",
			  NULL);

  adelta_item = xv_create(art_panel, PANEL_TEXT,
			  XV_X, 300,
			  XV_Y, 0,
			  PANEL_LAYOUT, PANEL_VERTICAL,
			  PANEL_LABEL_STRING, "delta",
			  PANEL_VALUE_DISPLAY_LENGTH, DISPLAY_LENGTH,
			  PANEL_VALUE_STORED_LENGTH, DISPLAY_LENGTH,
			  PANEL_VALUE, "0.000002",
			  NULL);

  atheta_item = xv_create(art_panel, PANEL_TEXT,
			  XV_X, 0,
			  XV_Y, 35,
			  PANEL_LAYOUT, PANEL_VERTICAL,
			  PANEL_LABEL_STRING, "theta",
			  PANEL_VALUE_DISPLAY_LENGTH, DISPLAY_LENGTH,
			  PANEL_VALUE_STORED_LENGTH, DISPLAY_LENGTH,
			  PANEL_VALUE, "0.0425",
			  NULL);

  avig_item = xv_create(art_panel, PANEL_TEXT,
			XV_X, 100,
			XV_Y, 35,
			PANEL_LAYOUT, PANEL_VERTICAL,
			PANEL_LABEL_STRING, "vig",
			PANEL_VALUE_DISPLAY_LENGTH, DISPLAY_LENGTH,
			PANEL_VALUE_STORED_LENGTH, DISPLAY_LENGTH,
			PANEL_VALUE, "0.9",
			NULL);

  aepoch_item = xv_create(art_panel, PANEL_TEXT,
			  XV_X, 200,
			  XV_Y, 35,
			  PANEL_LAYOUT, PANEL_VERTICAL,
			  PANEL_LABEL_STRING, "epoch",
			  PANEL_VALUE_DISPLAY_LENGTH, DISPLAY_LENGTH,
			  PANEL_VALUE_STORED_LENGTH, DISPLAY_LENGTH,
			  PANEL_VALUE, "80",
			  NULL);

  aneuron_item = xv_create(art_panel, PANEL_TEXT,
			   XV_X, 300,
			   XV_Y, 35,
			   PANEL_LAYOUT, PANEL_VERTICAL,
			   PANEL_LABEL_STRING, "neuron",
			   PANEL_VALUE_DISPLAY_LENGTH, DISPLAY_LENGTH,
			   PANEL_VALUE_STORED_LENGTH, DISPLAY_LENGTH,
			   PANEL_VALUE, "10",
			   NULL);

  alearn_item = xv_create(art_panel, PANEL_BUTTON,
			  XV_X, 0,
			  XV_Y, 70,
			  PANEL_LABEL_STRING, "learn",
			  PANEL_NOTIFY_PROC, exec_artlearn,
			  NULL);

  atest_item = xv_create(art_panel, PANEL_BUTTON,
			 XV_X, 0,
			 XV_Y, 100,
			 PANEL_LABEL_STRING, " test ",
			 PANEL_NOTIFY_PROC, test_artlearn,
			 NULL);

  aspeed_item = xv_create(art_panel, PANEL_CHOICE,
			  XV_X, 60,
			  XV_Y, 85,
			  PANEL_CHOOSE_ONE, TRUE,
			  PANEL_LABEL_STRING, "Speed",
			  PANEL_CHOICE_STRINGS, "slow", "fast", NULL,
			  PANEL_VALUE, 0,
			  NULL);

  ainput_item = xv_create(art_panel, PANEL_TEXT,
			  XV_X, 2,
			  XV_Y, 155,
			  PANEL_LAYOUT, PANEL_VERTICAL,
			  PANEL_LABEL_STRING, "Input file:",
			  PANEL_VALUE_DISPLAY_LENGTH, 20,
			  PANEL_VALUE, "",
			  NULL);

  aoutput_item = xv_create(art_panel, PANEL_TEXT,
			   XV_X, 2,
			   XV_Y, 190,
			   PANEL_LAYOUT, PANEL_VERTICAL,
			   PANEL_LABEL_STRING, "Output file:",
			   PANEL_VALUE_DISPLAY_LENGTH, 20,
			   PANEL_VALUE, "",
			   NULL);

  atpattern_item = xv_create(art_panel, PANEL_TEXT,
			     XV_X, 175,
			     XV_Y, 155,
			     PANEL_LAYOUT, PANEL_VERTICAL,
			     PANEL_LABEL_STRING, "Test pattern file:",
			     PANEL_VALUE_DISPLAY_LENGTH, 20,
			     PANEL_VALUE, "",
			     NULL);

  attarget_item = xv_create(art_panel, PANEL_TEXT,
			    XV_X, 175,
			    XV_Y, 190,
			    PANEL_LAYOUT, PANEL_VERTICAL,
			    PANEL_LABEL_STRING, "Test target file:",
			    PANEL_VALUE_DISPLAY_LENGTH, 20,
			    PANEL_VALUE, "",
			    NULL);

}

double check_parameter(item, event)
Panel_item item;
Event *event;
{
  double value;
  char label[20], messu[50];
  strcpy(label, (char *) xv_get(item, PANEL_LABEL_STRING));
  value = atof((char *) xv_get(item, PANEL_VALUE));
  switch (label[0]) {
  case 'a':
  case 'd':
  case 'z':
  case 'v':
    if ((value > 0) && (value < 1))
      return value;
  case 'b':
  case 'g':
  case 't':
    if (value > 0)
      return value;
  default:
    sprintf(messu, "Illegal value for %s", label);
    show_notice(current_panel, item, event, messu);
    return (0);
  }
}

void exec_artlearn(item, event)
Panel_item item;
Event *event;
{
  double alpha, beta, gam, delta, zeta, theta, vig;
  int speed, epoch, test = 0, neuron;
  char cmd_buf[500], patternfile[NAME_LEN], targetfile[NAME_LEN], ofile[NAME_LEN],
    ifile[NAME_LEN], tmp_buf[50];

  if ((alpha = check_parameter(aalpha_item, event)) == 0)
    return;
  if ((beta = check_parameter(abeta_item, event)) == 0)
    return;
  if ((gam = check_parameter(agamma_item, event)) == 0)
    return;
  if ((delta = check_parameter(adelta_item, event)) == 0)
    return;
  if ((theta = check_parameter(atheta_item, event)) == 0)
    return;
  if ((vig = check_parameter(avig_item, event)) == 0)
    return;

  /* not checked!!! */
  epoch = atoi((char *) xv_get(aepoch_item, PANEL_VALUE));
  neuron = atoi((char *) xv_get(aneuron_item, PANEL_VALUE));

  /* Are we going to learn or test something */
  if (item == atest_item)
    test = 1;

  /* Pattern and weight files are required for both learning	 */
  /* and testing ART2. In learning phase layer 1&2 weights	 */
  /* are stored into weightfile and in testing phase weights are	 */
  /* read from there	 */

  /* check pattern file name (required)	 */
  strcpy(patternfile, (char *) xv_get(pattern_item, PANEL_VALUE));
  if (strcmp(patternfile, "\0") == 0) {
    show_notice(current_panel, item, event, "No pattern file name");
    return;
  }
  /* check target file name (required)	 */
  strcpy(targetfile, (char *) xv_get(target_item, PANEL_VALUE));
  if (strcmp(targetfile, "\0") == 0) {
    show_notice(current_panel, item, event, "No target file name");
    return;
  }
  /* check output file name (required)	 */
  strcpy(ofile, (char *) xv_get(aoutput_item, PANEL_VALUE));
  if (strcmp(ofile, "\0") == 0) {
    show_notice(current_panel, item, event, "No file name for output");
    return;
  }
  /* learning takes place here	 */
  /* default command for artlearn	 */
  sprintf(cmd_buf, "%sartlearn -p %s -t %s -o %s -a %f -b %f -g %f -d %f -h %f -v %f -e %d -n %d",
	  BINDIR, patternfile, targetfile, ofile, alpha, beta, gam, delta, theta, vig, epoch, neuron);

  /*
   * if input file then we are going to use old weights for learning
   * strcpy(ifile,(char*)xv_get(ainput_item,PANEL_VALUE));
   * if(strcmp(ifile,"\0")!=0) { sprintf(tmp_buf, " -i %s",ifile);
   * strcat(cmd_buf,tmp_buf); }
   */

  /* check target file name (optional)	 */
  strcpy(targetfile, (char *) xv_get(target_item, PANEL_VALUE));
  if (strcmp(targetfile, "\0") != 0) {
    sprintf(tmp_buf, " -t %s", targetfile);
    strcat(cmd_buf, tmp_buf);
  }
  /* if fast learning selected then add it into parameter list */
  if (xv_get(aspeed_item, PANEL_VALUE))
    strcat(cmd_buf, " -f");


  printf("%s\n", cmd_buf);

  show_time(RUSAGE_CHILDREN);

  system(cmd_buf);

  printf("User time used in learning %d s\n", show_time(RUSAGE_CHILDREN));
}

void test_artlearn(item, event)
Panel_item item;
Event *event;
{
  MMatrix *a, *b, *c, *d, *g, *e, *tp, *tt, *W1, *M, *Z, *MAP;
  int correct, class, winner, **conf, q, dim, Nclasses, stab, stabilize = 6;
  register i, j;
  double tmp = 0.0, scalar = 0.0;
  double alpha, beta, gam, delta, zeta, theta;
  char ifile[NAME_LEN], tpatternfile[NAME_LEN], ttargetfile[NAME_LEN];

  /* check test pattern file name (required)      */
  strcpy(tpatternfile, (char *) xv_get(atpattern_item, PANEL_VALUE));
  if (strcmp(tpatternfile, "\0") == 0) {
    show_notice(current_panel, item, event, "No test pattern file name");
    return;
  }
  /* check test target file name (required)       */
  strcpy(ttargetfile, (char *) xv_get(attarget_item, PANEL_VALUE));
  if (strcmp(ttargetfile, "\0") == 0) {
    show_notice(current_panel, item, event, "No test target file name");
    return;
  }
  /* check input file name (required)       */
  strcpy(ifile, (char *) xv_get(ainput_item, PANEL_VALUE));
  if (strcmp(ifile, "\0") == 0) {
    show_notice(current_panel, item, event, "No input file name");
    return;
  }
  if ((alpha = check_parameter(aalpha_item, event)) == 0)
    return;
  if ((beta = check_parameter(abeta_item, event)) == 0)
    return;
  if ((gam = check_parameter(agamma_item, event)) == 0)
    return;
  if ((delta = check_parameter(adelta_item, event)) == 0)
    return;
  if ((theta = check_parameter(atheta_item, event)) == 0)
    return;

  /* LOAD WEIGHT FILE   */
  if ((W1 = load_matrix(ifile, "W1")) == NULL) {
    show_notice(current_panel, item, event, "Check input file");
    return;
  }
  if ((M = load_matrix(ifile, "M")) == NULL) {
    show_notice(current_panel, item, event, "Check input file");
    return;
  }
  /* LOAD TEST PATTERN AND TARGET FILES   */
  if ((tp = read_pattern_matrix(tpatternfile, 2)) == NULL) {
    show_notice(current_panel, item, event, "Check test pattern file");
    return;
  }
  if ((tt = read_target_matrix(ttargetfile)) == NULL) {
    show_notice(current_panel, item, event, "Check test target file");
    return;
  }
  dim = MxGetM(tp);
  Nclasses = MxGetM(tt);

  /* INITIALIZE CONFUSION MATRIX  */
  conf = init_confusion_matrix(Nclasses);

  MAP = Mmatinit(Nclasses, Nclasses, 0.0, "MAP", NULL);

  /* INITIALIZE LAYER 1 INTERNAL VARIABLES */
  a = Mmatinit(dim, 1, 0.0, "a", NULL);
  b = Mmatinit(dim, 1, 0.0, "b", NULL);
  c = Mmatinit(dim, 1, 0.0, "c", NULL);
  d = Mmatinit(dim, 1, 0.0, "d", NULL);
  g = Mmatinit(dim, 1, 0.0, "g", NULL);
  Z = Mmatinit(Nclasses, 1, 0.0, "Z", NULL);

  /* MAKE CONVERSION MAP FOR LAYER 2 NEURONS */
  for (q = 0; q < MxGetM(M); q++) {
    correct = MxGetPr(M)[1][q];
    winner = MxGetPr(M)[0][q];
    MxGetPr(MAP)[winner][correct] += 1;
  }

  show_time(RUSAGE_SELF);

  /* CLASSIFY PATTERN VECTORS */
  for (q = 0; q < MxGetN(tp); q++) {
    a = Mmatinit(dim, 1, 0.0, "a", a);
    b = Mmatinit(dim, 1, 0.0, "b", b);
    c = Mmatinit(dim, 1, 0.0, "c", c);
    d = Mmatinit(dim, 1, 0.0, "d", d);
    g = Mmatinit(dim, 1, 0.0, "g", g);
    for (stab = 0; stab < stabilize; stab++) {
      a = Mvecadd(tp, q, Mscalmul(alpha, c, NULL), 0, a);
      b = Mscalmul(1.0 / (gam + Mnorm(a)), a, b);
      d = Msigmoid(b, theta, d);
      c = Mscalmul(1.0 / (gam + Mnorm(d)), d, c);
      g = Mmatcopy(c, g);
    }

    Z = Mtransp(Mmatmul(Mtransp(g, NULL), W1, NULL), Z);
    winner = Mcompet(Z, 0);

    /* GET THE CORRECT CLASS FOR PATTERN VECTOR FROM TARGET MATRIX  */
    correct = Mcompet(tt, q);

    /* GET CLASSIFICATION RESULT */
    class = Mcompet(MAP, winner);

    /* UPDATE LINKED LIST */
    mark_class(q, class, correct, 2);

    /* UPDATE CONFUSION MATRIX      */
    update_confusion_matrix(conf, correct, class, Nclasses);
  }

  printf("User time used in classification %d s\n", show_time(RUSAGE_SELF));

  /* PRINT CONFUSION MATRIX       */
  xprint_confusion_matrix(conf, Nclasses, "ART");

  MxFreeMatrix(a);
  MxFree(a);
  MxFreeMatrix(b);
  MxFree(b);
  MxFreeMatrix(c);
  MxFree(c);
  MxFreeMatrix(d);
  MxFree(d);
  MxFreeMatrix(g);
  MxFree(g);
  MxFreeMatrix(tp);
  MxFree(tp);
  MxFreeMatrix(tt);
  MxFree(tt);
  MxFreeMatrix(W1);
  MxFree(W1);
  MxFreeMatrix(Z);
  MxFree(Z);
  MxFreeMatrix(M);
  MxFree(M);
  MxFreeMatrix(MAP);
  MxFree(MAP);
}
