/***********************************************************************
*                                                                      *
*                              SPECLASS                                *
*                                                                      *
*                                The                                   *
*                                                                      *
*                      Color Spectra Classifier                        *
*                                                                      *
*                          Program  Package                            *
*                                                                      *
*                           Programmed by			       *
*								       *
*			     J. Haanpalo		               *
*                                                                      *
*                      Copyright (c) 1993-1995                         *
*                                                                      *
************************************************************************
*                                                                      *
*  NOTE: This program package is copyrighted in the sense that it      *
*  may be used for scientific purposes. The package as a whole, or     *
*  parts thereof, cannot be included or used in any commercial         *
*  application without written permission granted by its producents.   *
*  No programs contained in this package may be copied for commercial  *
*  distribution. This program package comes 'as it is' and with no     *
*  warranty.                                                           *
*                                                                      *
*  All comments concerning this program package may be sent to the     *
*  e-mail address 'haanpalo@lut.fi'.                                   *
*                                                                      *
***********************************************************************/

#include <string.h>
#include <stdio.h>
#include <math.h>
#include <sys/wait.h>
#include "xglobal.h"
#include "global.h"
#include "matfile.h"

Event event;			/* XVIEW EVENT			 */

Panel_setting name_prog();	/* */

void select_format(),		/* SELECTS DATA FORMAT		 */
  save_files(),			/* SAVES SELECTED SPECTRA	 */
  clear_set(),			/* CLEARS SPECTRA LIST		 */
  load_prog(),			/* LOADS DATA FROM FILE		 */
  change_class(),		/* CHANGES CLASS DEFINITIONS	 */
  remove_spec();		/* REMOVES A SPECTRUM FROM LIST	 */

extern void inc_class(),	/* INCREASES CURRENT CLASS NUMBER	 */
  dec_class(),			/* DECREASES CURRENT CLASS NUMBER	 */
  toggle_down(),		/* HIGHLIGHTS PREVIOUS SPECTRUM IN LIST	 */
  toggle_up(),			/* HIGHLIGHTS NEXT SPECTRUM IN LIST	 */
  view_class(),			/* SHOWS ALL SPECTRA IN CURRENT CLASS	 */
  draw_empty_spec();		/* CLEARS CANVAS 			 */

/* FILE PANEL INITIALIZATION	*/
void init_editor_panel()
{
  Menu_item mi, create_menu();

  /* CREATE MENU */
  spec_dir = MUNSELLDIR;
  mi = create_menu(MUNSELLDIR);
  spec_menu = (Menu) xv_get(mi, MENU_PULLRIGHT);
  xv_destroy(mi);

  /* PANEL ITEM DEFINITIONS AND PLACEMENT	 */
  editor_panel = xv_create(editor_frame, PANEL,
			   XV_X, 0,
			   XV_Y, 0,
			   XV_WIDTH, 750,
			   XV_HEIGHT, 300,
			   NULL);

  load_format_item = xv_create(editor_panel, PANEL_CHOICE,
			       XV_X, 4,
			       XV_Y, 4,
			       PANEL_LAYOUT, PANEL_VERTICAL,
			       PANEL_CHOOSE_ONE, TRUE,
			       PANEL_LABEL_STRING, "LOAD FORMAT",
			 PANEL_CHOICE_STRINGS, " RAW UCHAR ", " RAW SHORT ",
		    " MUNSELL ", " NATURAL ", " MINOLTA ", " MATLAB ", NULL,
			       PANEL_VALUE, 2,
			       PANEL_NOTIFY_PROC, select_format,
			       NULL);

  save_format_item = xv_create(editor_panel, PANEL_CHOICE,
			       XV_X, 4,
			       XV_Y, 180,
			       PANEL_LAYOUT, PANEL_VERTICAL,
			       PANEL_CHOOSE_ONE, TRUE,
			       PANEL_LABEL_STRING, "SAVE FORMAT",
			  PANEL_CHOICE_STRINGS, " ASCII ", " MATLAB ", NULL,
			       PANEL_VALUE, 1,
			       NULL);

  type_item = xv_create(editor_panel, PANEL_CHOICE_STACK,
			XV_X, 540,
			XV_Y, 210,
			PANEL_CHOOSE_ONE, TRUE,
			PANEL_LAYOUT, PANEL_VERTICAL,
			PANEL_LABEL_STRING, "DATA TYPE",
	 PANEL_CHOICE_STRINGS, " SCALED ", " NORMALIZED ", "  RAW   ", NULL,
			PANEL_VALUE, 0,
			NULL);

  load_item = xv_create(editor_panel, PANEL_BUTTON,
			XV_X, 650,
			XV_Y, 4,
			PANEL_LABEL_STRING, "   Load   ",
			PANEL_NOTIFY_PROC, load_prog,
			NULL);

  spectra_item = xv_create(editor_panel, PANEL_BUTTON,
			   XV_X, 540,
			   XV_Y, 4,
			   PANEL_LABEL_STRING, "Spectra",
			   PANEL_ITEM_MENU, spec_menu,
			   PANEL_CLIENT_DATA, editor_frame,
			   NULL);

  load_pfile_item = xv_create(editor_panel, PANEL_TEXT,
			      XV_X, 120,
			      XV_Y, 4,
			      PANEL_LAYOUT, PANEL_VERTICAL,
			      PANEL_LABEL_STRING, "Load pattern file:",
			      PANEL_VALUE_DISPLAY_LENGTH, 50,
			      PANEL_VALUE, "",
			      NULL);

  load_tfile_item = xv_create(editor_panel, PANEL_TEXT,
			      XV_X, 120,
			      XV_Y, 44,
			      PANEL_LAYOUT, PANEL_VERTICAL,
			      PANEL_LABEL_STRING, "Load target file:",
			      PANEL_VALUE_DISPLAY_LENGTH, 50,
			      PANEL_VALUE, "",
			      NULL);

  save_pfile_item = xv_create(editor_panel, PANEL_TEXT,
			      XV_X, 120,
			      XV_Y, 180,
			      PANEL_LAYOUT, PANEL_VERTICAL,
			      PANEL_LABEL_STRING, "Save pattern filename:",
			      PANEL_VALUE_DISPLAY_LENGTH, 50,
			      PANEL_VALUE, "",
			      NULL);

  save_tfile_item = xv_create(editor_panel, PANEL_TEXT,
			      XV_X, 120,
			      XV_Y, 220,
			      PANEL_LAYOUT, PANEL_VERTICAL,
			      PANEL_LABEL_STRING, "Save target filename:",
			      PANEL_VALUE_DISPLAY_LENGTH, 50,
			      PANEL_VALUE, "",
			      NULL);

  maxval_item = xv_create(editor_panel, PANEL_TEXT,
			  XV_X, 220,
			  XV_Y, 90,
			  PANEL_LAYOUT, PANEL_VERTICAL,
			  PANEL_LABEL_STRING, "Max value",
			  PANEL_VALUE_DISPLAY_LENGTH, DISPLAY_LENGTH,
			  PANEL_VALUE_STORED_LENGTH, DISPLAY_LENGTH,
			  PANEL_VALUE, "4096",
			  NULL);

  dim_item = xv_create(editor_panel, PANEL_TEXT,
		       XV_X, 120,
		       XV_Y, 90,
		       PANEL_LAYOUT, PANEL_VERTICAL,
		       PANEL_LABEL_STRING, "Channels",
		       PANEL_VALUE_DISPLAY_LENGTH, DISPLAY_LENGTH,
		       PANEL_VALUE_STORED_LENGTH, DISPLAY_LENGTH,
		       PANEL_VALUE, "31",
		       NULL);

  save_item = xv_create(editor_panel, PANEL_BUTTON,
			XV_X, 650,
			XV_Y, 210,
			PANEL_LABEL_STRING, "   Save   ",
			PANEL_NOTIFY_PROC, save_files,
			PANEL_CLIENT_DATA, editor_frame,
			NULL);

  clear_item = xv_create(editor_panel, PANEL_BUTTON,
			 XV_X, 540,
			 XV_Y, 44,
			 PANEL_LABEL_STRING, "Clear selections",
			 PANEL_NOTIFY_PROC, clear_set,
			 PANEL_CLIENT_DATA, editor_frame,
			 NULL);

  (void) xv_create(editor_panel, PANEL_MESSAGE,
		   XV_X, 565,
		   XV_Y, 130,
		   PANEL_LABEL_STRING, "Toggle class",
		   PANEL_LABEL_BOLD, TRUE,
		   NULL);

  eddec_item = xv_create(editor_panel, PANEL_BUTTON,
			 XV_X, 540,
			 XV_Y, 150,
			 PANEL_LABEL_STRING, "Dec",
			 PANEL_NOTIFY_PROC, dec_class,
			 PANEL_CLIENT_DATA, editor_frame,
			 NULL);

  edinc_item = xv_create(editor_panel, PANEL_BUTTON,
			 XV_X, 650,
			 XV_Y, 150,
			 PANEL_LABEL_STRING, "Inc",
			 PANEL_NOTIFY_PROC, inc_class,
			 PANEL_CLIENT_DATA, editor_frame,
			 NULL);

  edclass_item = xv_create(editor_panel, PANEL_TEXT,
			   XV_X, 595,
			   XV_Y, 150,
			   PANEL_VALUE_DISPLAY_LENGTH, 4,
			   PANEL_READ_ONLY, TRUE,
			   PANEL_VALUE, "0",
			   NULL);

  (void) xv_create(editor_panel, PANEL_MESSAGE,
		   XV_X, 410,
		   XV_Y, 90,
		   PANEL_LABEL_STRING, "Toggle spectrum",
		   PANEL_LABEL_BOLD, TRUE,
		   NULL);

  eddown_item = xv_create(editor_panel, PANEL_BUTTON,
			  XV_X, 410,
			  XV_Y, 115,
			  PANEL_LABEL_STRING, " << ",
			  PANEL_NOTIFY_PROC, toggle_down,
			  PANEL_CLIENT_DATA, editor_frame,
			  NULL);

  edup_item = xv_create(editor_panel, PANEL_BUTTON,
			XV_X, 480,
			XV_Y, 115,
			PANEL_LABEL_STRING, " >> ",
			PANEL_NOTIFY_PROC, toggle_up,
			PANEL_CLIENT_DATA, editor_frame,
			NULL);

  edmax_class_item = xv_create(editor_panel, PANEL_TEXT,
			       XV_X, 320,
			       XV_Y, 90,
			       PANEL_LAYOUT, PANEL_VERTICAL,
			       PANEL_LABEL_STRING, "Max class",
			       PANEL_VALUE_DISPLAY_LENGTH, 4,
			       PANEL_VALUE, "10",
			       NULL);

  edview_class_item = xv_create(editor_panel, PANEL_CHOICE,
				XV_X, 540,
				XV_Y, 80,
		     PANEL_CHOICE_STRINGS, " View all ", "View class", NULL,
				PANEL_VALUE, 0,
				PANEL_NOTIFY_PROC, view_class,
				PANEL_CLIENT_DATA, editor_frame,
				NULL);

  change_item = xv_create(editor_panel, PANEL_BUTTON,
			  XV_X, 410,
			  XV_Y, 150,
			  PANEL_LABEL_STRING, "Set current class",
			  PANEL_NOTIFY_PROC, change_class,
			  NULL);

  rem_spec = xv_create(editor_panel, PANEL_BUTTON,
		       XV_X, 265,
		       XV_Y, 150,
		       PANEL_LABEL_STRING, "Remove spectrum",
		       PANEL_NOTIFY_PROC, remove_spec,
		       NULL);

  /* SET SOME PANEL ITEMS INACTIVE	 */
  xv_set(load_pfile_item, PANEL_INACTIVE, TRUE, NULL);
  xv_set(load_tfile_item, PANEL_INACTIVE, TRUE, NULL);
  xv_set(load_item, PANEL_INACTIVE, TRUE, NULL);
  xv_set(dim_item, PANEL_INACTIVE, TRUE, NULL);
  xv_set(spectra_item, PANEL_INACTIVE, FALSE, NULL);
  xv_set(maxval_item, PANEL_INACTIVE, FALSE, NULL);
}

/* SELECT_FORMAT(ITEM, EVENT)					*/
/* ACTIVATES AND INACTIVATES PANEL ITEMS FOR DATA FORMATS	*/
/* PARAMETERS:							*/
/*              ITEM    CALLING PANEL ITEM			*/
/*              EVENT   ACTION EVENT (MOUSE BUTTON PRESSED)	*/
/* RETURNS:							*/
/*              NOTHING						*/
void select_format(item, event)
Panel_item item;
Event *event;
{
  Menu_item mi, create_menu();
  void destroy_menu();

  switch (xv_get(item, PANEL_VALUE)) {
  case RAW_UCHAR:
    xv_set(spectra_item, PANEL_INACTIVE, TRUE, NULL);
    xv_set(load_pfile_item, PANEL_INACTIVE, FALSE, NULL);
    xv_set(load_tfile_item, PANEL_INACTIVE, FALSE, NULL);
    xv_set(load_item, PANEL_INACTIVE, FALSE, NULL);
    xv_set(maxval_item, PANEL_INACTIVE, FALSE, NULL);
    xv_set(dim_item, PANEL_INACTIVE, FALSE, NULL);
    break;
  case RAW_SHORT:
    xv_set(spectra_item, PANEL_INACTIVE, TRUE, NULL);
    xv_set(load_pfile_item, PANEL_INACTIVE, FALSE, NULL);
    xv_set(load_tfile_item, PANEL_INACTIVE, FALSE, NULL);
    xv_set(load_item, PANEL_INACTIVE, FALSE, NULL);
    xv_set(maxval_item, PANEL_INACTIVE, FALSE, NULL);
    xv_set(dim_item, PANEL_INACTIVE, FALSE, NULL);
    break;
  case MUNSELL_DATA:
    xv_set(load_pfile_item, PANEL_INACTIVE, TRUE, NULL);
    xv_set(load_tfile_item, PANEL_INACTIVE, TRUE, NULL);
    xv_set(load_item, PANEL_INACTIVE, TRUE, NULL);
    xv_set(dim_item, PANEL_INACTIVE, TRUE, NULL);
    xv_set(spectra_item, PANEL_INACTIVE, FALSE, NULL);
    xv_set(maxval_item, PANEL_INACTIVE, FALSE, NULL);

    if (spec_dir != MUNSELLDIR) {
      /* DESTROY OLD MENU AND CREATE NEW ONE */
      destroy_menu(spec_menu);
      spec_dir = MUNSELLDIR;
      mi = create_menu(MUNSELLDIR);
      spec_menu = (Menu) xv_get(mi, MENU_PULLRIGHT);
      xv_destroy(mi);
      xv_set(spectra_item, PANEL_ITEM_MENU, spec_menu, NULL);
    }
    break;
  case NATURAL_DATA:
    xv_set(load_pfile_item, PANEL_INACTIVE, TRUE, NULL);
    xv_set(load_tfile_item, PANEL_INACTIVE, TRUE, NULL);
    xv_set(load_item, PANEL_INACTIVE, TRUE, NULL);
    xv_set(dim_item, PANEL_INACTIVE, TRUE, NULL);
    xv_set(spectra_item, PANEL_INACTIVE, FALSE, NULL);
    xv_set(maxval_item, PANEL_INACTIVE, FALSE, NULL);

    if (spec_dir != NATURALDIR) {
      /* DESTROY OLD MENU AND CREATE NEW ONE */
      destroy_menu(spec_menu);
      spec_dir = NATURALDIR;
      mi = create_menu(NATURALDIR);
      spec_menu = (Menu) xv_get(mi, MENU_PULLRIGHT);
      xv_destroy(mi);
      xv_set(spectra_item, PANEL_ITEM_MENU, spec_menu, NULL);
    }
    break;
  case MINOLTA_DATA:
    xv_set(load_pfile_item, PANEL_INACTIVE, TRUE, NULL);
    xv_set(load_tfile_item, PANEL_INACTIVE, TRUE, NULL);
    xv_set(load_item, PANEL_INACTIVE, TRUE, NULL);
    xv_set(dim_item, PANEL_INACTIVE, TRUE, NULL);
    xv_set(spectra_item, PANEL_INACTIVE, FALSE, NULL);
    xv_set(maxval_item, PANEL_INACTIVE, FALSE, NULL);
    break;
  case MATLAB_DATA:
    xv_set(spectra_item, PANEL_INACTIVE, TRUE, NULL);
    xv_set(dim_item, PANEL_INACTIVE, TRUE, NULL);
    xv_set(load_pfile_item, PANEL_INACTIVE, FALSE, NULL);
    xv_set(load_tfile_item, PANEL_INACTIVE, FALSE, NULL);
    xv_set(load_item, PANEL_INACTIVE, FALSE, NULL);
    xv_set(maxval_item, PANEL_INACTIVE, FALSE, NULL);
    break;
  }
}

/* SAVE_FILES(ITEM,EVENT)					*/
/* CREATES PATTERN AND TARGET FILES FROM THE SPECTRA LIST	*/
/* IF SAVE SET BUTTON IS PRESSED.				*/
/* PARAMETERS:							*/
/*              ITEM    CALLING PANEL ITEM			*/
/*              EVENT   ACTION EVENT (MOUSE BUTTON PRESSED)	*/
/* RETURNS:							*/
/*              NOTHING						*/
void save_files(item, event)
Panel_item item;
Event *event;
{
  Menu submenu;
  Menu_item menu_item;
  FILE *rfp, *wfp;
  Spec *spr = NULL;
  int spec_count = 0, i, j, tmp = 0, ccount = 0, rows = 0;
  char spectrum[20], linebuf[LINE_LEN], fname[NAME_LEN], classname[10], messu[2000],
    pfile[NAME_LEN], tfile[NAME_LEN];
  double *dbuf;

  /* CHECK FILE NAMES	 */
  strcpy(pfile, (char *) xv_get(save_pfile_item, PANEL_VALUE));
  if (strcmp(pfile, "\0") == 0) {
    show_notice(editor_panel, item, event, "No pattern file name");
    return;
  }
  strcpy(tfile, (char *) xv_get(save_tfile_item, PANEL_VALUE));
  if (strcmp(tfile, "\0") == 0) {
    show_notice(editor_panel, item, event, "No target file name");
    return;
  }
  if (start == NULL) {
    show_notice(editor_panel, item, event, "No selections made");
    return;
  }
  /* FREE OLD MATRICES	 */
  free_globals();

  /* LVQ NEEDS PATTERNS SAVED IN ASCII FORMAT	 */
  if ((wfp = fopen(check_ext(pfile, DAT), "w")) == NULL) {
    perror("fopen");
    exit(1);
  }
  fprintf(wfp, "%d\n", start->dim);

  spr = start;
  rows = atoi((char *) xv_get(edmax_class_item, PANEL_VALUE));
  while (spr) {
    /* APPEND SPECTRUM INTO PATTERN MATRIX */
    create_pattern(spr->data, spr->dim);

    /* ADD THE CLASS AND LABEL OF SPECTRUM INTO CNTABLE	 */
    sprintf(messu, "%-5s %-14s", spr->file, spr->label);
    create_table(&cntable, messu);

    /* UPDATE TARGET MATRIX	 */
    create_target(spr->class, rows);

    /* WRITE SPECTRUM IN ASCII FORMAT (LVQ)	 */
    fprintf(wfp, "%s\n", make_ascii_vector(spr->data, spr->dim, spr->class));

    spec_count++;
    spr = spr->next;
  }
  fclose(wfp);

  /* SHOW THE NUMBER OF SELECTIONS MADE	 */
  sprintf(messu, "%d spectra saved", spec_count);
  xv_set(frame, FRAME_LEFT_FOOTER, messu, NULL);

  /* WHEN ALL MENUS ARE SEARCHED SAVE MATRICES	 */
  /* SHOW WARNING IF NO SELECTIONS ARE MADE	 */
  if (!spec_count) {
    show_notice(editor_panel, item, event, "No selections made");
    return;
  }
  if (!write_pattern_matrix(pfile)) {
    printf("Couldn't write pattern_matrix\n");
    return;
  }
  resize_target(rows);
  if (!write_target_matrix(tfile)) {
    printf("Couldn't write target_matrix\n");
    return;
  }
}

/* CLEAR_SET(ITEM,EVENT)						*/
/* CLEARS ALL SPECTRA SELECTIONS WHEN CLEAR SET BUTTON IS PRESSED	*/
/* CLEARING IS DONE BY DESTROYING THOSE SUBMENUS IN WHICH THERE EXISTS	*/
/* SELECTED SPECTRA. THIS IS ONE WAY TO AVOID THE PROBLEMS WITH UPDATING*/
/* SUBFRAMES.								*/
/* PARAMETERS:								*/
/*              ITEM    CALLING PANEL ITEM				*/
/*              EVENT   ACTION EVENT (MOUSE BUTTON PRESSED)		*/
/* RETURNS:								*/
/*              NOTHING							*/
void clear_set(item, event)
Panel_item item;
Event *event;
{
  Menu submenu, subsubmenu;
  register i, j;
  /* SEARCH ALL SELECTED SPECTRA BY INSPECTING THE MENU_SELECTED	 */
  /* ATTRIBUTE OF EVERY SUBMENU ITEMS				 */
  for (i = 2; i <= (int) xv_get(spec_menu, MENU_NITEMS); i++)
    if (submenu = (Menu) xv_get(xv_get(spec_menu, MENU_NTH_ITEM, i), MENU_PULLRIGHT)) {
      for (j = 1; j <= (int) xv_get(submenu, MENU_NITEMS); j++)
	if (subsubmenu = (Menu) xv_get(xv_get(submenu, MENU_NTH_ITEM, j), MENU_PULLRIGHT)) {
	  xv_free(xv_get(subsubmenu, MENU_CLIENT_DATA));
	  xv_set(subsubmenu, MENU_CLIENT_DATA, NULL, NULL);
	}
      xv_free(xv_get(submenu, MENU_CLIENT_DATA));
      xv_set(submenu, MENU_CLIENT_DATA, NULL, NULL);
    }
  destroy_list(&start);
  list1_total = 0;
  highlight = 0;

  /* SHOW THE NUMBER OF SELECTIONS MADE	 */
  xv_set(frame, FRAME_LEFT_FOOTER, "All selections removed", NULL);
}

/* LOAD_PROG(ITEM,EVENT)						*/
/* LOADS RAW_UCHAR, RAW_SHORT AND MATLAB DATA FROM FILE.		*/
/* PARAMETERS:								*/
/*              ITEM    CALLING PANEL ITEM				*/
/*              EVENT   ACTION EVENT (MOUSE BUTTON PRESSED)		*/
/* RETURNS:								*/
/*              NOTHING							*/
void load_prog(item, event)
Panel_item item;
Event *event;
{
  FILE *fp;
  Spec *next;
  int spec_count = 0, class, dim = 0, type, veclen = 0, view_mode = 0,
    cno, i, maxval;
  char linebuf[LINE_LEN], pfile[NAME_LEN], tfile[NAME_LEN], file[NAME_LEN],
    label[NAME_LEN], messu[100];
  unsigned char *cdata;
  short *sdata;
  MMatrix *M;
#ifdef GCC
  double dbuf[300] = {0};
#else
  double dbuf[300];
  register j;
  for(j=0;j<300;j++)
    dbuf[j] = 0.0;
#endif

  /* CHECK PATTERN FILE NAME (REQUIRED)	 */
  strcpy(pfile, (char *) xv_get(load_pfile_item, PANEL_VALUE));
  if (strcmp(pfile, "\0") == 0) {
    show_notice(editor_panel, item, event, "No pattern file name");
    return;
  }
  /* CHECK TARGET FILE NAME (OPTIONAL)	 */
  strcpy(tfile, (char *) xv_get(load_tfile_item, PANEL_VALUE));

  /* GET PARAMETERS FOR SPECTRUM	 */
  class = atoi((char *) xv_get(class_item, PANEL_VALUE));
  type = (int) xv_get(type_item, PANEL_VALUE);

  /* READ A SPECTRUM OR SPECTRA (MATLAB) */
  switch ((int) xv_get(load_format_item, PANEL_VALUE)) {

  case RAW_UCHAR:
    dim = (int) xv_get(dim_item, PANEL_VALUE);
    cdata = (unsigned char *) malloc(dim);

    if ((fp = fopen(check_ext(pfile, MAT), "r")) == NULL) {
      perror("fopen");
      exit(1);
    }
    if (fread(cdata, 1, dim, fp) != dim) {
      fclose(fp);
      free(cdata);
      return;
    }
    fclose(fp);
    for (i = 0; i < dim; i++)
      dbuf[i] = (double) cdata[i];
    free(cdata);

    list1_total++;

    /* ADD SPECTRUM WITH ITS PARAMETERS TO LINKED LIST	 */
    sprintf(messu, "%d", list1_total);
    make_spectrum(class, dim, type, pfile, messu, dbuf, &start);

    break;

  case RAW_SHORT:
    dim = (int) xv_get(dim_item, PANEL_VALUE);
    sdata = (short *) malloc(dim * sizeof(short));
    if ((fp = fopen(check_ext(pfile, MAT), "r")) == NULL) {
      perror("fopen");
      exit(1);
    }
    if (fread(sdata, sizeof(short), dim, fp) != dim) {
      fclose(fp);
      free(sdata);
      return;
    }
    fclose(fp);
    for (i = 0; i < dim; i++)
      dbuf[i] = (double) sdata[i];
    free(sdata);

    list1_total++;

    /* ADD SPECTRUM WITH ITS PARAMETERS TO LINKED LIST	 */
    sprintf(messu, "%d", list1_total);
    make_spectrum(class, dim, type, pfile, messu, dbuf, &start);

    break;

  case MATLAB_DATA:

    if ((M = read_pattern_matrix(pfile, 1)) == NULL) {
      show_notice(editor_panel, item, event, "Check pattern file");
      return;
    }
    MxFreeMatrix(M);
    MxFree(M);

    if (strcmp(tfile, "\0") != 0) {
      if ((M = read_target_matrix(tfile)) == NULL) {
	show_notice(editor_panel, item, event, "Cannot read target");
	return;
      }
      /* SET THE CLASSES OF SPECTRA	 */
      for (i = 0; i < MxGetN(M); i++)
	mark_class(i, -1, Mcompet(M, i), 1);

      MxFreeMatrix(M);
      MxFree(M);
    }
    /* SHOW THE NUMBER OF SPECTRA	 */
    sprintf(messu, "%d spectra", list1_total);
    xv_set(frame, FRAME_LEFT_FOOTER, messu, NULL);

    /* SHOW SPECTRUM ON THE SCREEN IF CORRECT VIEW MODE IS SELECTED	 */
    view_mode = (int) xv_get(edview_class_item, PANEL_VALUE);
    if (view_mode == 0)
      draw_list(start);
    else {
      cno = atoi((char *) xv_get(edclass_item, PANEL_VALUE));
      /* CLEAR CANVAS AND DRAW COORDINATE AXIS */
      draw_empty_spec();
      draw_class(start, cno);
    }
    return;
  }

  /* PROCESS SPECTRUM (NOT MATLAB) IF NEEDED	 */
  switch (type) {
  case SCALED:
    scale(dbuf, dim, maxval);
    break;
  case NORMALIZED:
    normalize(dbuf, dim);
    break;
  case RAW:
    break;
  }

  /* SHOW THE NUMBER OF SPECTRA	 */
  sprintf(messu, "%d spectra", list1_total);
  xv_set(frame, FRAME_LEFT_FOOTER, messu, NULL);

  /* SHOW SPECTRA ON THE SCREEN IF CORRECT VIEW MODE IS SELECTED	 */
  view_mode = (int) xv_get(edview_class_item, PANEL_VALUE);
  if (view_mode == 0)
    draw_list(start);
  else {
    cno = atoi((char *) xv_get(edclass_item, PANEL_VALUE));
    /* CLEAR CANVAS AND DRAW COORDINATE AXIS */
    draw_empty_spec();
    draw_class(start, cno);
  }
}

/* CHANGE_CLASS(ITEM,EVENT)						*/
/* CHANGES THE CLASS OF THE HIGHLIGHTED SPECTRUM TO THE CLASS CURRENTLY	*/
/* SHOWN BY EDCLASS_ITEM						*/
/* PARAMETERS:								*/
/*              ITEM    CALLING PANEL ITEM				*/
/*              EVENT   ACTION EVENT (MOUSE BUTTON PRESSED)		*/
/* RETURNS:								*/
/*              NOTHING							*/
void change_class(item, event)
Panel_item item;
Event *event;
{
  /* RETURN IF THE LIST IS EMPTY */
  if (start == NULL)
    return;

  /* CHANGE THE CLASS OF THE HIGHLIGHTED SPECTRUM */
  mark_class(highlight, -1, atoi((char *) xv_get(edclass_item, PANEL_VALUE)), 1);
}

/* REMOVE_SPEC(ITEM,EVENT)						*/
/* REMOVES THE HIGHLIGHTED SPECTRUM FROM LIST				*/
/* PARAMETERS:								*/
/*              ITEM    CALLING PANEL ITEM				*/
/*              EVENT   ACTION EVENT (MOUSE BUTTON PRESSED)		*/
/* RETURNS:								*/
/*              NOTHING							*/
void remove_spec(item, event)
Panel_item item;
Event *event;
{
  Spec *spec;
  char messu[20];

  /* RETURN IF THE LIST IS EMPTY */
  if (start == NULL)
    return;

  /* GET HIGHLIGHTED SPECTRUM FROM THE LIST 1 */
  spec = get_spec(start, highlight);

  /* DELETE SPECTRUM FROM THE LIST 1 */
  delete_spectrum(spec->file, spec->label, &start);

  /* DECREASE TOTAL NUMBER OF SPECTRA IN LIST 1 */
  list1_total -= 1;

  /* SHOW SPECTRA ON THE SCREEN IF CORRECT VIEW MODE IS SELECTED	 */
  if ((int) xv_get(edview_class_item, PANEL_VALUE) == 0)
    draw_list(start);
  else {
    /* CLEAR CANVAS AND DRAW COORDINATE AXIS */
    draw_empty_spec();
    draw_class(start, atoi((char *) xv_get(edclass_item, PANEL_VALUE)));
  }

  /* SHOW THE NUMBER OF SPECTRA	 */
  sprintf(messu, "%d spectra", list1_total);
  xv_set(frame, FRAME_LEFT_FOOTER, messu, NULL);
}

/* Panel_setting name_prog(item, event)
Panel_item item;
Event *event;
{
	Menu_item mi, create_menu();
	void destroy_menu();

	switch(xv_get(load_format_item,PANEL_VALUE)) {
	case RAW_UCHAR:
	case RAW_SHORT:
	case MATLAB_DATA:
		return (panel_text_notify(item, event));
	}

	switch(event_action(event)) {
	case '\n':
	case '\r':
		/* DESTROY OLD MENU AND CREATE NEW ONE
		destroy_menu(spec_menu);
		mi = create_menu(xv_get(item, PANEL_VALUE));
		spec_menu = (Menu)xv_get(mi, MENU_PULLRIGHT);
		xv_destroy(mi);
		xv_set(spectra_item, PANEL_ITEM_MENU, spec_menu, NULL);
	default:
		return (panel_text_notify(item, event));
	}
} */
