/***********************************************************************
*                                                                      *
*                              SPECLASS                                *
*                                                                      *
*                                The                                   *
*                                                                      *
*                      Color Spectra Classifier                        *
*                                                                      *
*                          Program  Package                            *
*                                                                      *
*                  Version 0.8 (October 17, 1994)                      *
*                                                                      *
*                           Programmed by			       *
*								       *
*			     J. Haanpalo		               *
*                                                                      *
*                      Copyright (c) 1993-1994                         *
*                                                                      *
************************************************************************
*                                                                      *
*  NOTE: This program package is copyrighted in the sense that it      *
*  may be used for scientific purposes. The package as a whole, or     *
*  parts thereof, cannot be included or used in any commercial         *
*  application without written permission granted by its producents.   *
*  No programs contained in this package may be copied for commercial  *
*  distribution. This program package comes 'as it is' and with no     *
*  warranty.                                                           *
*                                                                      *
*  All comments concerning this program package may be sent to the     *
*  e-mail address 'haanpalo@lut.fi'.                                   *
*                                                                      *
***********************************************************************/

#define MxGetM(mat) ((mat->rows))
#define MxGetN(mat) ((mat->cols))
#define MxGetPr(mat) ((mat->data))

typedef struct M_Matrix {
        int rows;
        int cols;
        int type;
        char *name;
        double **data;
} MMatrix;

extern void printmat();
extern void errmsg();
extern void discriminant();
extern void normalize();
extern void scale();
/*extern Matrix *matinit();
extern Matrix *matdiag();
extern Matrix *transp();
extern Matrix *matadd();
extern Matrix *matsub();
extern Matrix *matmul();
extern Matrix *scalmul();
extern Matrix *colmul();
extern Matrix *coladd();
extern Matrix *colsub();
extern Matrix *vecmul();
extern Matrix *vecadd();
extern Matrix *vecsub();
extern Matrix *matcopy();
extern Matrix *colapp();
extern Matrix *matext();
extern Matrix *matmerge();
extern Matrix *normc();
extern Matrix *logsig();
extern Matrix *purelin();
extern Matrix *tansig();
extern Matrix *sigmoid();
extern Matrix *rando();
extern Matrix *orth();
extern Matrix *distances();
extern Matrix *sort();*/
extern double norm();
extern double inprod();
extern double print_confusion_matrix();
extern int compet();
extern int compet2();
extern int bmu();

extern int all();
extern int hardlim();
extern int **init_confusion_matrix();
extern int update_confusion_matrix();
extern int save_matrix();
extern char *check_ext();

extern void Mprintmat();
extern void Mdiscriminant();

extern void MxFreeMatrix();
extern void MxFree();
extern void MxSetName();
extern void MxCheckTemp();

extern int MatPutMatrix();
extern int MatPutString();
extern int MatGetString();
extern char *MxGetName();

extern MMatrix *MxCreateFull();
extern MMatrix *MxCheckReuse();
extern MMatrix *matlab2own();
extern MMatrix *MatGetMatrix();

extern double MxGetScalar();

/*extern Matrix *own2matlab();*/

extern MMatrix *Mmatinit();
extern MMatrix *Mmatdiag();
extern MMatrix *Mtransp();
extern MMatrix *Mmatadd();
extern MMatrix *Mmatsub();
extern MMatrix *Mmatmul();
extern MMatrix *Mscalmul();
extern MMatrix *Mcolmul();
extern MMatrix *Mcoladd();
extern MMatrix *Mcolsub();
extern MMatrix *Mvecmul();
extern MMatrix *Mvecadd();
extern MMatrix *Mvecsub();
extern MMatrix *Mmatcopy();
extern MMatrix *Mcolapp();
extern MMatrix *Mmatext();
extern MMatrix *Mmatmerge();
extern MMatrix *Mnormc();
extern MMatrix *Mlogsig();
extern MMatrix *Mpurelin();
extern MMatrix *Mtansig();
extern MMatrix *Msigmoid();
extern MMatrix *Mrando();
extern MMatrix *Morth();
extern MMatrix *Mdistances();
extern MMatrix *Msort();
extern MMatrix *load_matrix();
extern double Mnorm();
extern double Minprod();
extern double print_confusion_matrix();
extern int Mcompet();
extern int Mcompet2();
extern int Mbmu();
extern int Mall();
extern int Mhardlim();
extern int **init_confusion_matrix();
extern int update_confusion_matrix();
extern int save_matrix();
extern char *check_ext();
