/***********************************************************************
*                                                                      *
*                              SPECLASS                                *
*                                                                      *
*                                The                                   *
*                                                                      *
*                      Color Spectra Classifier                        *
*                                                                      *
*                          Program  Package                            *
*                                                                      *
*                           Programmed by			       *
*								       *
*			     J. Haanpalo		               *
*                                                                      *
*                      Copyright (c) 1993-1995                         *
*                                                                      *
************************************************************************
*                                                                      *
*  NOTE: This program package is copyrighted in the sense that it      *
*  may be used for scientific purposes. The package as a whole, or     *
*  parts thereof, cannot be included or used in any commercial         *
*  application without written permission granted by its producents.   *
*  No programs contained in this package may be copied for commercial  *
*  distribution. This program package comes 'as it is' and with no     *
*  warranty.                                                           *
*                                                                      *
*  All comments concerning this program package may be sent to the     *
*  e-mail address 'haanpalo@lut.fi'.                                   *
*                                                                      *
***********************************************************************/

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>		
#include <X11/X.h>

#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/svrimage.h>
#include <xview/xv_xrect.h>
#include <xview/cms.h> 
#include <xview/font.h>
#include <xview/notice.h>

#define FRAME_W		750	/* width of the main frame	*/
#define FRAME_H		850	/* height of the main frame	*/
#define EDFRAME_W	750	/* width of the editor frame	*/
#define EDFRAME_H	300	/* height of the editor frame	*/
#define HFRAME_W	550	/* width of the help frame	*/
#define HFRAME_H	300	/* height of the help frame	*/
#define CANVAS_W	740	/* width of the canvas		*/
#define CANVAS_H	300	/* width of the canvas		*/
#define DISPLAY_LENGTH	10	/* display length for numerical parameters */

/* global Xview-variables */
Frame 		frame,
		editor_frame,
		help_frame;
Canvas 		canvas;
Menu 		spec_menu;
Textsw		textsw;
Textsw		helpsw1;
Textsw		helpsw2;
Rect		rect;
Icon		icon;
Server_image	spec_icon;

/* definition of panel types */
Panel 		main_panel,
		editor_panel,
		art_panel,
		bp_panel,
		som_panel,
		lvq_panel,
		lsm_panel,
		knn_panel,
		current_panel;


/* panel items hold the status of items of panel buttons etc. */
/* main_panel items	*/
Panel_item 	method_item,
		help_item,
		quit_item,
		editor_item,
		pattern_item,
		target_item,
		text_item,
		class_item,
		max_class_item,
		view_class_item,
		up_item,
		down_item,
		dec_item,
		inc_item;

/* editor_panel items	*/
Panel_item	load_format_item,
		load_pfile_item,
		load_tfile_item,
		save_format_item,
		save_pfile_item,
		save_tfile_item,
		load_item,
		type_item,
		fileop_item,
		spectra_item,
		maxval_item,
		dim_item,
		save_item,
		clear_item,
		edclass_item,
		edmax_class_item,
		edview_class_item,
		edup_item,
		eddown_item,
		eddec_item,
		edinc_item,
		change_item,
		rem_spec;

/* Shows notices in a popup window	*/ 
Xv_opaque show_notice();

/* Prints confusion matrix onto canvas	*/
extern void xprint_confusion_matrix();


